Module Module1
    
    Sub Main()
        ' Create some columns
        Dim dcID As New DataColumn("ID", GetType(System.Int32))
        Dim dcQty As New DataColumn("Qty", GetType(System.Int32))
        Dim dcPrice As New DataColumn("Price", GetType(System.Int32))
        Dim dcTotalPrice As New DataColumn("TotalPrice", GetType(System.Int32))

        ' Add the columns to the table
        Dim dtAuthors As New DataTable("Authors")
        dtAuthors.Columns.Add(dcID)
        dtAuthors.Columns.Add(dcQty)
        dtAuthors.Columns.Add(dcPrice)
        dtAuthors.Columns.Add(dcTotalPrice)

        ' Create a DataSet and add the table to it
        Dim dsAuthors As New DataSet("dsAuthors")
        dsAuthors.Tables.Add(dtAuthors)

        ' Add three records to the table
        Dim drNewRow As DataRow

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 1
        drNewRow("Qty") = 10
        drNewRow("Price") = 120
        dtAuthors.Rows.Add(drNewRow)

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 2
        drNewRow("Qty") = 20
        drNewRow("Price") = 240
        dtAuthors.Rows.Add(drNewRow)

        drNewRow = dtAuthors.NewRow()
        drNewRow("ID") = 3
        drNewRow("Qty") = 30
        drNewRow("Price") = 360
        dtAuthors.Rows.Add(drNewRow)

        dtAuthors.AcceptChanges()

        ' Create a TotalPrice column
        dsAuthors.Tables(0).Columns("TotalPrice").Expression = "Qty * Price"

        Dim r As DataRow

        For Each r In dsAuthors.Tables(0).Rows
            Console.WriteLine(r("TotalPrice"))
        Next

    End Sub
    
End Module
