using System;
using System.Web;
using System.Web.UI.WebControls;

namespace Chapter09.Ex01
{
	public class Chapter09_Ex01 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.CheckBox CheckBox1;
		protected System.Web.UI.WebControls.TextBox txtUserID;
		protected System.Web.UI.WebControls.Button Button1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
            {
                HttpCookie ckSave = Request.Cookies["IDSave"];
                if (ckSave != null && ckSave.Value != "")
                    CheckBox1.Checked = (ckSave.Value == true.ToString());

                HttpCookie ckId = Request.Cookies["ID"];
                if (ckId != null && ckId.Value != "")
                    txtUserID.Text = ckId.Value;
            }
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.Button1.Click += new System.EventHandler(this.Button1_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void Button1_Click(object sender, System.EventArgs e)
		{
			if (CheckBox1.Checked)
			{
				Response.Cookies["ID"].Value = txtUserID.Text;
				Response.Cookies["ID"].Expires = DateTime.MaxValue;
			}
			else
			{
				Response.Cookies["ID"].Value = null;
				Response.Cookies["ID"].Expires = DateTime.MinValue;
			}
			Response.Cookies["IDSave"].Value = CheckBox1.Checked.ToString();
			Response.Cookies["IDSave"].Expires = DateTime.MaxValue;
		}
	}
}
