using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using System.IO;
using System.Web.Caching;

namespace Chapter10
{
	/// <summary>
	/// WebForm1   Դϴ.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Label Label1;
		protected WebUserControl1 WebUserControl11;
		protected WebUserControl1 WebUserControl12;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			/*
			Label1.Text = "ð :" + DateTime.Now.ToString() + "<br>";
			Label1.Text += "Brower Version :" + Request.Browser.Version + "<br>";
			Label1.Text += "ClrVersion :" + Request.Browser.ClrVersion + "<br>";
			*/
			/*
			if (!IsPostBack)
			{
				//  Ʈ ɽ϶ WebUserControl12 null ǹǷ  .
				WebUserControl12.Message = "  ٲ";
			}
			*/
			
			Cache.Insert("CacheKey1","CachedData1");
			Cache["CacheKey2"] = "CachedData2";

			Cache.Add("CacheKey2", "", null, DateTime.MaxValue , TimeSpan.Zero, CacheItemPriority.High, null);

			string c1 = (string)Cache.Get("CacheKey1");
			string c2 = (string)Cache["CacheKey2"];

			Cache.Remove("CacheKey1");
			Cache.Remove("CacheKey2");

			/****************************************
			 * Ͱ ҸǴ ð 
			 * 
			 * 
			 * 븸ð Ȱȭ
			 * System.Web.Caching.Cache.NoAbsoluteExpiration 
			 ****************************************/
			
			Cache.Insert("CacheKey3", DateTime.Now, null, DateTime.Now.AddMinutes(10), TimeSpan.Zero);

			/****************************************
			 * ͸  ׼   ð ȸ Ҹ
			 * 
			 * 
			 *  ð Ȱȭ 
			 * System.Web.Caching.Cache.NoSlidingExpiration
			 * Ǵ
			 * TimeSpan.Zero
			 ****************************************/

			Cache.Insert("CacheKey4", DateTime.Now, null, Cache.NoAbsoluteExpiration, TimeSpan.FromMinutes(10));
			
			//Ϳ Ư Ͽ  Ӱ 
			DataSet ds;
			if (Cache["CacheKey5"] != null)
			{
				ds = new DataSet();
				FileStream fs = new FileStream(@"C:\UserInfo.xml", FileMode.Open, FileAccess.Read);
				StreamReader sr = new StreamReader(fs);
				ds.ReadXml(sr);
				Cache.Insert("CacheKey5", ds, new CacheDependency(@"C:\UserInfo.xml"));
			}
			else
				ds = (DataSet)Cache["CacheKey5"];

			
			//ĳÿ  ٸ Ϳ  Ӱ 
			String[] sKeys = new String[2];
			sKeys[0] = "CacheKey3";
			sKeys[1] = "CacheKey5";
			CacheDependency dep = new CacheDependency(null, sKeys);
			Cache.Insert("CacheKey5", "ٸ Ϳӵ ", dep, DateTime.Now.AddHours(1), TimeSpan.Zero);
			//Ǵ
			Cache.Insert("CacheKey5", "ٸ Ϳӵ ", dep);

			/****************************************
			 *  켱 ϱ
			 * 
			 * 
			 * System.Web.Caching.CacheItemPriority   
			 * 
			 * 켱 ( )
			 * 1. Low
			 * 2. BelowNormal
			 * 3. Normal Ǵ Default
			 * 4. AboveNormal
			 * 5. High
			 * 6. NotRemovable (޸   ʴ´)
			 ****************************************/
			Cache.Insert("CacheKey6", DateTime.Now, null, DateTime.MaxValue, TimeSpan.Zero, CacheItemPriority.NotRemovable, null);

			/****************************************
			 * Ͱ ŵɶ ݹ ޼ҵ ȣ 
			 * 
			 * 
			 * CacheItemRemovedReason 
			 * 1. DependencyChanged - Ӽ
			 * 2. Expired - ð 
			 * 3. Removed - Remove ȣ̳  Ű Isert ȣؼ  
			 * 4. Underused - ޸ 
			 ****************************************/
			CacheItemRemovedCallback onRemove = new CacheItemRemovedCallback(this.RemovedCallback);

			//2Ŀ Ǹ鼭 RemovedCallback ޼ҵ带 ȣѴ.
			Cache.Insert("CacheKey7", DateTime.Now, null, DateTime.Now.AddMinutes(2), TimeSpan.Zero, CacheItemPriority.Normal, onRemove);
		}

		/// <summary>
		/// Ͱ ĳÿ ŵɶ ȣǴ
		/// CacheItemRemovedCallback  ޼ҵ
		/// </summary>
		/// <param name="key">ĳ Ű</param>
		/// <param name="value">Ǵ </param>
		/// <param name="reason">Ŵ </param>
		public void RemovedCallback(String key, Object value, CacheItemRemovedReason reason)
		{
			string logFile = "C:\\Chap10_RemovedCallback.log";

			FileStream fs = new FileStream(logFile,
				FileMode.Append, FileAccess.Write);

			StreamWriter sw = new StreamWriter(fs, System.Text.Encoding.Default);
			sw.WriteLine(DateTime.Now.ToString() + "   :");
			sw.WriteLine("\t" + "Ű = " + key);
			sw.WriteLine("\t" + " = " + value.ToString());
			sw.WriteLine("\t" + " = " + reason.ToString());
			sw.WriteLine();
			sw.Flush( );
			sw.Close( );

			CacheItemRemovedCallback onRemove = new CacheItemRemovedCallback(this.RemovedCallback);
			Cache.Insert(key, DateTime.Now, null, DateTime.Now.AddMinutes(2), TimeSpan.Zero, CacheItemPriority.Normal, onRemove);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
