using System;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Web;
using System.Web.Services;
using System.Configuration;
using System.Drawing;
using System.Drawing.Text;
using System.Drawing.Imaging;
using System.IO;

namespace WebServices.Ex02
{
	public class Chap16_Ex02 : System.Web.Services.WebService
	{
		public Chap16_Ex02()
		{
			//CODEGEN:  ȣ ASP.NET   ̳ʿ ʿմϴ.
			InitializeComponent();
		}

		#region Component Designer generated code
		
		//  ̳ʿ ʿմϴ. 
		private IContainer components = null;
				
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
		}

		/// <summary>
		///    ҽ մϴ.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if(disposing && components != null)
			{
				components.Dispose();
			}
			base.Dispose(disposing);		
		}
		
		#endregion

		//DataSet ü ȯ
		[WebMethod]
		public DataSet GetDataSet()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation1";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

			DataSet ds = new DataSet();
			da.Fill(ds, "DataPresentation2");
			return ds;
		}

		//int  ڷ ް ȯ
		[WebMethod]
		public int GetIntegerType(int a, int b)
		{
			return a + b;
		}

		//string  ڷ ް ȯ
		[WebMethod]
		public string GetStringType(string str)
		{
			return "\"" + str + "\" ڿ ";
		}

		//   Ŭ ȯ
		[WebMethod]
		public MyDataType GetMyDataType()
		{
			MyDataType md = new MyDataType();
			md.IntegerType = 100;
			md.StringType = "ڿ";
			return md;
		}

		//byte 迭 ȯ
		[WebMethod]
		public byte[] GetImage(string text)
		{
			Bitmap oImage = new Bitmap(120,100);
			Graphics oGraphics = Graphics.FromImage(oImage);
			MemoryStream memStream = new MemoryStream();

			//Ʈ   ĥѴ
			oGraphics.FillRectangle(new SolidBrush(Color.White),
				0,0,120,100);
			//׷ ؽƮ Ƽ ٸ ǵѴ
			oGraphics.TextRenderingHint = TextRenderingHint.AntiAlias;
			//Ʈ 10 ȸ
			oGraphics.RotateTransform(10);
			//Ʈ㿡 ޼ҵ ڷ Ѿ ڸ 
			oGraphics.DrawString(text,new Font("", 16.0F),
				new SolidBrush(Color.Blue), 10.0F, 10.0F, 
				new StringFormat());
			//ϼ Ʈ Gif  ޸ Ʈ 
			oImage.Save(memStream, ImageFormat.Gif);

			oGraphics.Dispose();
			oImage.Dispose();

			//Ʈ ͸ byte 迭 ȯ
			return memStream.ToArray();
		}
	}

	//  Ŭ
	public class MyDataType
	{
		public string StringType;
		public int IntegerType;
	}
}
