<%@ Page language="c#" %>
<%@ Import Namespace="System.Data"%>
<%@ Import Namespace="System.Data.SqlClient"%>
<%@ Import Namespace="System.Configuration"%>
<script runat="server">
	void Page_Load(object sender, System.EventArgs e)
	{
		SqlConnection conn = new SqlConnection(ConfigurationSettings.AppSettings["SqlConnectionString"]);
		SqlDataAdapter da = new SqlDataAdapter("SELECT * FROM tbADO_TUT_3_PARENT", conn);
		SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(da);
		SqlCommand cmd;

		cmd = cmdBuilder.GetInsertCommand();
		Response.Write("<h3>InsertCommand</h3>");
		DisplayCommandDetail(cmd);

		cmd = cmdBuilder.GetUpdateCommand();
		Response.Write("<h3>UpdateCommand</h3>");
		DisplayCommandDetail(cmd);

		cmd = cmdBuilder.GetDeleteCommand();
		Response.Write("<h3>DeleteCommand</h3>");
		DisplayCommandDetail(cmd);
	}

	void DisplayCommandDetail(SqlCommand cmd)
	{
		string nbsp = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";

		Response.Write("CommandText : " + cmd.CommandText + "<br><br>");
		Response.Write("CommandType : " + cmd.CommandType + "<br><br>");
		Response.Write("Parameters : <br>");
		foreach(SqlParameter parm in cmd.Parameters)
		{
			Response.Write(nbsp + "ParameterName = " + parm.ParameterName + "<br>");
			Response.Write(nbsp + "SourceColumn = " + parm.SourceColumn + "<br>");
			Response.Write(nbsp + "DbType = " + parm.DbType + "<br>");
		}
		Response.Write("<br><br>");
	}
</script>
