<%@ Page smartNavigation="True" %>
<%@ Register TagPrefix="PC" Namespace="CustomControls.PracticalControls" Assembly="CustomControls" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data" %>
<HTML>
	<script runat="server">
void Page_Load(object sender, System.EventArgs e)
{
	PagerSkinGrid1.PageIndexChanged += new DataGridPageChangedEventHandler(PagerSkinGrid1_PageIndexChanged);
	PagerSkinGrid2.PageIndexChanged += new DataGridPageChangedEventHandler(PagerSkinGrid2_PageIndexChanged);
	if (!IsPostBack) {
		PagerSkinGrid1.DataSource = CreateDataSource();
		PagerSkinGrid1.DataBind();
		PagerSkinGrid2.DataSource = CreateDataSource();
		PagerSkinGrid2.DataBind();
	}

	Label1.Controls.Add(PagerSkinGrid2.ExportedPager);
	Label1.Controls.Add(new LiteralControl("<br>"));
	Label1.Controls.Add(PagerSkinGrid1.ExportedPager);
	Label2.Controls.Add(PagerSkinGrid1.ExportedPager);
}

ICollection CreateDataSource() 
{
	DataTable dt = new DataTable();
	DataRow dr;

	dt.Columns.Add(new DataColumn("IntegerValue", typeof(Int32)));
	dt.Columns.Add(new DataColumn("StringValue", typeof(string)));
	dt.Columns.Add(new DataColumn("CurrencyValue", typeof(double)));

	
	for (int i = 0; i < 1000; i++) {
		dr = dt.NewRow();

		dr[0] = i;
		dr[1] = "Item " + i.ToString();
		dr[2] = 1.23 * (i + 1);

		dt.Rows.Add(dr);
	}

	DataView dv = new DataView(dt);
	return dv;
}

void PagerSkinGrid1_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
{
	PagerSkinGrid1.CurrentPageIndex = e.NewPageIndex;
	PagerSkinGrid1.DataSource= CreateDataSource();
	PagerSkinGrid1.DataBind();
}

void PagerSkinGrid2_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
{
	PagerSkinGrid2.CurrentPageIndex = e.NewPageIndex;
	PagerSkinGrid2.DataSource= CreateDataSource();
	PagerSkinGrid2.DataBind();
}
	</script>
	<BODY>
		<form method="post" runat="server">
			<asp:Label id="Label1" runat="server"></asp:Label>
			<BR>
			<h3>PagerSkinGrid1 :</h3>
			<pc:PagerSkinGrid id="PagerSkinGrid1" runat="server" AllowPaging="True" EnablePagerSkin="True" PagerSkinFile="TestSkin1.skn" EnableExportPager="True" Width="85%" PageSize="3" BackColor="Snow"></pc:PagerSkinGrid>
			<br>
			<h3>PagerSkinGrid2 :</h3>
			<pc:PagerSkinGrid id="PagerSkinGrid2" runat="server" AllowPaging="True" EnablePagerSkin="True" PagerSkinFile="TestSkin2.skn" EnableExportPager="True" Width="85%" PageSize="3" BackColor="Beige">
				<PagerStyle PageButtonCount="5" Mode="NumericPages"></PagerStyle>
			</pc:PagerSkinGrid>
			<br>
			<asp:Label id="Label2" runat="server"></asp:Label>
		</form>
	</BODY>
</HTML>
