using System;
using System.IO;
using System.Web;
using System.Web.Caching;
using System.Data;
using PowerOfDotNet.TypedDataSet;

namespace PowerOfDotNet.NewStudy.DownloadBoard
{
	public class GetDownloadFile : IHttpHandler
	{
		public void ProcessRequest(HttpContext context)
		{
			int id = Convert.ToInt32(context.Request.QueryString["id"]);
			string strFileName = context.Request.QueryString["file"].ToString().Trim();

			PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();
			DownloadDS od = (DownloadDS)context.Cache["__Obj"+"DownloadDS"];
			if (od == null)
			{
				od = db.CreateDownloadDS();
				context.Cache.Insert("__Obj"+"DownloadDS", od, null, DateTime.Now.AddMinutes(30), TimeSpan.Zero, CacheItemPriority.High, null);
			}
			db.IncFileDownload(od, id);

			//ٿε   ͸ Ѵ.
			string filePath = context.Request.MapPath("/NewStudy/DownloadBoard/UploadFiles/");
			filePath += id + "/" + strFileName;
			FileInfo fi = new FileInfo(filePath);

			context.Response.AddHeader("Content-Disposition","attachment;filename="+ context.Server.UrlEncode(strFileName) );
			context.Response.ContentType = "application/unknown";
			context.Response.WriteFile(filePath, 0, fi.Length);
			context.Response.End();
		}

		public bool IsReusable
		{
			get { return true; }
		}
	}
}
