namespace PowerOfDotNet.NewStudy.DownloadBoard
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using PowerOfDotNet.TypedDataSet;

	/// <summary>
	///		ReviewsWriter   Դϴ.
	/// </summary>
	public abstract class ReviewsWrite : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Button btnWrite;
		protected System.Web.UI.WebControls.TextBox txtComment;

		protected string _subject;

		private void Page_Load(object sender, System.EventArgs e)
		{
			DownloadDS od = (DownloadDS)this.GetObjectFromCache("DownloadDS");
			if (od == null)
			{
				PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();
				od = db.CreateDownloadDS();
			}

			if (!IsPostBack)
			{
				int	dnID = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.QueryString["id"], -1);
				string page  = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.QueryString["page"], "");

				DownloadDS.DownloadBoardRow row = od.DownloadBoard.FindBydnID(dnID);
				_subject = row.dnSubject;

				this.DataBind();
				ViewState["dnID"] = dnID;
				ViewState["page"] = page;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWrite.Click += new System.EventHandler(this.btnWrite_Click);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void btnWrite_Click(object sender, System.EventArgs e)
		{
			DownloadDS od = (DownloadDS)this.GetObjectFromCache("DownloadDS");
			if (od == null)
			{
				PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();
				od = db.CreateDownloadDS();
			}

			string writerID = "";
			int dnID = (int)ViewState["dnID"];
			PowerOfDotNet.Components.DownloadDB dbDownload = new PowerOfDotNet.Components.DownloadDB();
			dbDownload.AddReview(od, dnID, txtComment.Text, writerID);

			string page = (string)ViewState["page"];
			Response.Redirect(GetLink("ڷǸƮ") + "&page=" + page);
		}
	}
}
