namespace PowerOfDotNet.Templates
{
	using System;
	using System.Data;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		MyPageTemplate01   Դϴ.
	/// </summary>
	public abstract class MyPageTemplate01 : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.HtmlControls.HtmlTableCell LeftPane;
		protected System.Web.UI.HtmlControls.HtmlTableCell ContentPane;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink1;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink2;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink3;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink4;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink5;
		protected MyWebLibs.ServerControls.RollOverHyperLink Rolloverhyperlink6;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
				this.Page.DataBind();
		}

		//#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			base.OnInit(e);

			//Ʈ  εҶ ̷
			//InitializeComponent base.OnInit  ȣǾѴ.
			//OnInit޼ҵ忡  Ʈ  Ե Ʈѵ ʱȭ ȴ.
			InitializeComponent();

			// Obtain PortalSettings from Current Context
			PortalSettings portalSettings = (PortalSettings) HttpContext.Current.Items["PortalSettings"];
        
			// Ensure that the visiting user has access to the current page
			if (PortalSecurity.IsInRoles(portalSettings.ActivePage.AuthorizedRoles) == false) 
			{
				if (!PortalSecurity.IsInRole("Users"))
					Response.Redirect(GetLink("α") + "&ReturnUrl=" + Request.RawUrl.Replace("&","$"));
				else
					Response.Redirect("~/Admin/AccessDenied.aspx");
			}

			// Dynamically Populate the Left, Center and Right pane sections of the portal page
			if (portalSettings.ActivePage.Modules.Count > 0) 
			{

				// Loop through each entry in the configuration system for this tab
				foreach (ModuleSettings _moduleSettings in portalSettings.ActivePage.Modules) 
				{

					//O Control ø ֽ̹ ֱ⶧ FindControlδ ã.
					Control parent = MyWebLibs.Utilities.CommonMethods.FindControlAll(this, _moduleSettings.PaneName);

					// If no caching is specified, create the user control instance and dynamically
					// inject it into the page.  Otherwise, create a cached module instance that
					// may or may not optionally inject the module into the tree

					if ((_moduleSettings.CacheTime) == 0) 
					{
						PortalModuleControl portalModule = (PortalModuleControl) Page.LoadControl(_moduleSettings.DesktopSrc);
                   
						portalModule.PortalId = portalSettings.PortalId;                                  
						portalModule.ModuleConfiguration = _moduleSettings;
                   
						parent.Controls.Add(portalModule);
					}
					else 
					{
						//CachedPortalModuleControlEx portalModule = new CachedPortalModuleControlEx();
						CachedPortalModuleControl portalModule = new CachedPortalModuleControl();
                   
						portalModule.PortalId = portalSettings.PortalId;                                 
						portalModule.ModuleConfiguration = _moduleSettings;
 
						parent.Controls.Add(portalModule);
					}

					// Dynamically inject separator break between portal modules
					//parent.Controls.Add(new LiteralControl("<" + "br" + ">"));
					parent.Visible = true;
				}
			}
		}
		
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		//#endregion
	}
}
