/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs.Board
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		ClubReply   Դϴ.
	/// </summary>
	public abstract class ClubReply : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnFormat;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.HtmlControls.HtmlInputFile File1;
		protected System.Web.UI.HtmlControls.HtmlInputFile File2;
		protected System.Web.UI.HtmlControls.HtmlInputFile File3;
		protected System.Web.UI.HtmlControls.HtmlInputFile File4;
		protected System.Web.UI.HtmlControls.HtmlInputFile File5;
		protected System.Web.UI.HtmlControls.HtmlInputFile File6;
		protected System.Web.UI.HtmlControls.HtmlInputFile File7;
		protected System.Web.UI.HtmlControls.HtmlInputFile File8;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndList;
		protected System.Web.UI.WebControls.Panel pnlOrg;
		protected System.Web.UI.HtmlControls.HtmlAnchor aOrg;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndBefore;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Panel pnlHeader;

		private string ClubTogleOrgScript = @"
<script language=""javascript"">
		<!--
		function _PowerOf_TogleOrg(objId) 
		{
			if (document.all[objId].style.display == ""none"") 
			{
				document.all[objId].style.display = """";
			}
			else 
			{
				document.all[objId].style.display = ""none"";
			}
		}
		//-->
		</script>
";
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;

		private PowerOfDotNet.Components.BoardClubInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);
			int clubId = CommonMethods.RequestInt(Request.Params["clubId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			this.RemoveObjectCache("BoardClubTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardClubInfo)this.GetObjectFromCache("BoardClubTableInfo" + boardId);
			if (_blInfo == null)
			{
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardClubTableInfo" + boardId, _blInfo, 30);
			}

			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)
			{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}

			if (!IsPostBack)
			{
				Components.ClubInfo clubInfo = Clubs.ClubsUtil.GetClubInfo(this, clubId);
				bool gongJiAuthority = Clubs.ClubsUtil.CheckUserAuthorityForGongJi(Page.User.Identity.Name, clubInfo, _blInfo);
				if (!gongJiAuthority) MyWebLibs.Utilities.CommonMethods.PrintMsgBack("Ŭ ڸ   ֽϴ.");

				ViewState["before"] = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["before"], "").Replace("^","=").Replace("$","&");
				//ViewState["TableName"] = tableName;
				ViewState["genParam"] = "page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["page"],"") + 
					"&TableId=" + boardId + "&clubId=" + clubId;

				int pid = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["pid"], 0);
				ViewState["pid"] = pid;
				PowerOfDotNet.Components.BoardClubDB db = new PowerOfDotNet.Components.BoardClubDB();
				SqlDataReader dr = db.GetContent(_blInfo.BBSTable, pid);
				dr.Read();
				string org = Server.HtmlEncode(dr.GetString(3)).Replace("\n","<br>");
				pnlOrg.Controls.Clear();
				pnlOrg.Controls.Add(new LiteralControl(org));
				pnlOrg.Attributes["style"] = "display:none;";
				aOrg.Attributes["href"] = "javascript:_PowerOf_TogleOrg('" + pnlOrg.ClientID + "');";
				//txtWriter.Text = dr.GetString(0);
				txtSubject.Text = "[Re]" + dr.GetString(1);
				//txtRegDate.Text = dr.GetDateTime(2).ToString();
				//lblViewed.Text = dr.GetInt32(4).ToString();
				//rdobtnFormat.SelectedIndex = dr.GetByte(6);
				dr.Close();

				this.Form.Enctype = "multipart/form-data";

				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();
				rdobtnlstAvatarExp.SelectedIndex = 0;
			}
			this.Page.RegisterClientScriptBlock("ClubTogleOrgScript", ClubTogleOrgScript);
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWriteAndList.ServerClick += new System.EventHandler(this.btnWriteAndList_ServerClick);
			this.btnWriteAndBefore.ServerClick += new System.EventHandler(this.btnWriteAndBefore_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private PowerOfDotNet.Components.BoardClubData MakeDbData()
		{
			PowerOfDotNet.Components.BoardClubData oData = new PowerOfDotNet.Components.BoardClubData();
			
			if (Request.IsAuthenticated)
			{
				UsersDB dbUser = new UsersDB();
				SqlDataReader dr = dbUser.GetSingleUser(this.Page.User.Identity.Name);
				dr.Read();

				oData.UserID = this.Page.User.Identity.Name;
				oData.Writer = dr["Name"].ToString();
				oData.Email = dr["Email"].ToString();
			}
			else
			{
				oData.UserID = "";
				oData.Writer = "";
				oData.Email = "";
			}
			oData.PID = Convert.ToInt32(ViewState["pid"]);
			oData.Subject = txtSubject.Text;
			oData.Format = Convert.ToByte(rdobtnFormat.SelectedItem.Value);
			oData.Content = txtContent.Text;
			oData.UserIP = Request.ServerVariables["REMOTE_ADDR"];
			oData.UseAvatar = chkboxUseAvatar.Checked;
			oData.AvatarExpression = Convert.ToByte(rdobtnlstAvatarExp.SelectedItem.Value);

			return oData;
		}

		private void btnWriteAndList_ServerClick(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardClubData oData = MakeDbData();
			PowerOfDotNet.Components.BoardClubDB oDb = new PowerOfDotNet.Components.BoardClubDB();
			oDb.InsertReply(_blInfo.BBSTable, oData, Request.Files);
			Response.Redirect(GetLink(_blInfo.BBSPageNameList) + "&" + (string)ViewState["genParam"]);
		}

		private void btnWriteAndBefore_ServerClick(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardClubData oData = MakeDbData();
			PowerOfDotNet.Components.BoardClubDB oDb = new PowerOfDotNet.Components.BoardClubDB();
			oDb.InsertReply(_blInfo.BBSTable, oData, Request.Files);
			Response.Redirect((string)ViewState["before"]);
		}

	}
}
