namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		MemberList   Դϴ.
	/// </summary>
	public abstract class MemberList : PowerOfDotNet.PortalModuleControlEx
	{
		protected MyWebLibs.ServerControls.PagerSkinGrid pagerskngrdMemberList;
		protected System.Web.UI.WebControls.Label lblMemberCount;

		private int _clubId;
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			if (!IsPostBack)
			{
				BindData();
			}
		}

		private void BindData()
		{
			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			DataSet ds = db.GetClubUserList(_clubId);
			pagerskngrdMemberList.DataSource = ds.Tables[0].DefaultView;
			pagerskngrdMemberList.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
