/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Clubs
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		SubClubMenu   Դϴ.
	/// </summary>
	public abstract class SubClubMenu : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.Image imgClass;
		protected System.Web.UI.WebControls.Label lblClass;
		protected System.Web.UI.WebControls.Label lblClubName;
		protected System.Web.UI.WebControls.HyperLink hyplnkSubClubHome;
		protected System.Web.UI.WebControls.HyperLink hyplnkJoinInfoModify;
		protected System.Web.UI.WebControls.HyperLink hyplnkClubWithdrawal;
		protected System.Web.UI.WebControls.DropDownList drpdnlstMenuList;
		protected System.Web.UI.WebControls.HyperLink hyplnkClubManagement;
		protected System.Web.UI.WebControls.HyperLink hyplnkMemberList;

		private int _clubId;
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);

			if (!this.IsPostBack)
			{
				//string casheKey = "objClub_" + _clubId;
				//PowerOfDotNet.Components.ClubInfo clubInfo = (PowerOfDotNet.Components.ClubInfo)this.GetObjectFromCache(casheKey);
				Components.ClubInfo clubInfo = ClubsUtil.GetClubInfo(this, _clubId);

				string subject = clubInfo.subject;
				string sysopId = clubInfo.sysopId;
				string sysopName = clubInfo.sysopName;
				int classId = clubInfo.classId;

				lblClubName.Text = subject;

				string userId = this.Page.User.Identity.Name;
				if (userId == sysopId)
				{
					hyplnkClubManagement.Visible = true;
					hyplnkClubManagement.NavigateUrl = this.GetLink("Ŭ") + "&clubId=" + _clubId;
				}

				lblClass.Text = clubInfo.className;
				imgClass.ImageUrl = clubInfo.classImagePath;

				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
				SqlDataReader drBoardList = db.GetBoardList(_clubId);
				drpdnlstMenuList.DataSource = drBoardList;
				drpdnlstMenuList.DataTextField = "Subject";
				drpdnlstMenuList.DataValueField = "ID";
				drpdnlstMenuList.DataBind();

				drpdnlstMenuList.Items.Insert(0, new ListItem("-- Խ  --", "0"));
				drpdnlstMenuList.SelectedIndex = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["dlIdx2"], 0);

				hyplnkSubClubHome.NavigateUrl = GetLink("Ŭ") + "&clubId=" + _clubId;
				hyplnkMemberList.NavigateUrl = GetLink("Ŭȸ") + "&clubId=" + _clubId;
				hyplnkJoinInfoModify.NavigateUrl = "javascript:OpenJoinInfoModifyWin(" + _clubId + ",'" + GetLink("Ŭ").Replace("=","^").Replace("&","$") + "')";
				hyplnkClubWithdrawal.NavigateUrl = "javascript:WithdrawalFromClub(" + _clubId + ",'" + GetLink("Ŭ").Replace("=","^").Replace("&","$") + "')";
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.drpdnlstMenuList.SelectedIndexChanged += new System.EventHandler(this.drpdnlstMenuList_SelectedIndexChanged);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void drpdnlstMenuList_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (((DropDownList)sender).SelectedIndex == 0)
				Response.Redirect(GetLink("Ŭ") + "&clubId=" + _clubId);
			else
			{
				int id = Convert.ToInt32(((DropDownList)sender).SelectedItem.Value);
				Response.Redirect(GetLink("Ŭ_") + "&TableId=" + id + "&clubId=" + _clubId + "&dlIdx2=" + ((DropDownList)sender).SelectedIndex);
			}
		}
	}
}
