/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Home
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.Security;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		Login   Դϴ.
	/// </summary>
	public abstract class Login : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtLoginID;
		protected System.Web.UI.WebControls.TextBox txtLoginPassword;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.Button btnLogin;

		private void Page_Load(object sender, System.EventArgs e)
		{
			MyWebLibs.Utilities.CommonMethods.SetFocus(txtLoginID);
			DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnLogin.Click += new System.EventHandler(this.btnLogin_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnLogin_Click(object sender, System.EventArgs e)
		{
			if (!Page.IsValid)
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ID йȣ Ȯ ϼž մϴ.");

			// Attempt to Validate User Credentials using UsersDB
			UsersDB user = new UsersDB();
			String userName = user.Login(txtLoginID.Text, txtLoginPassword.Text);

			if ((userName != null) && (userName != "")) 
			{
				// Use security system to set the UserID within a client-side Cookie
				//FormsAuthentication.SetAuthCookie(txtLoginID1.Value, false);
				SqlDataReader dr = user.GetSingleUser(txtLoginID.Text);
				dr.Read();
				string dbUserName = dr["Name"].ToString();
				string dbUserDir = dr["UserDirectory"].ToString();
				dr.Close();
				dbUserDir = this.MapPath("/User/UserDir/" + dbUserDir + "/" + txtLoginID.Text);
				PowerOfDotNet.Components.PortalUtil.MakeWelcomeImage(dbUserName, dbUserDir);
				
				FormsAuthentication.SetAuthCookie(txtLoginID.Text, false);
				string redirUrl = Request.QueryString["ReturnUrl"];
				if (redirUrl == null) redirUrl = "/";
				Response.Redirect(redirUrl.Replace("$","&"));
			}
			else 
			{
				MyWebLibs.Utilities.CommonMethods.PrintMsgBack("ԷϽ ID йȣ  Ƚϴ.");
			}
		}
	}
}
