<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SQL" %>
<html>
<head>
 <title>ASPNextGen.com - Paging in the DataGrid Part 1</title>
 <script runat="server" language="VB">
 Sub Page_Load(Source As Object, E As EventArgs)
   If Not Page.IsPostBack Then
     BindData()
   End If
 End Sub

 Sub BindData()
   Dim ds As New DataSet
   Dim dsc As SQLDataSetCommand
   Dim strSQL As String
   Dim strCon As String

   strSQL = "SELECT CompanyName, ContactName, ContactTitle, Phone, Fax FROM Customers ORDER BY CompanyName"
   strCon = "server=localhost;database=Northwind;uid=sa;pwd=;"

   dsc = New SQLDataSetCommand(strSQL, strCon)
   dsc.FillDataSet(ds, "Customers")

   myDataGrid.DataSource = ds.Tables("Customers").DefaultView
   myDataGrid.DataBind()
 End Sub

 Sub myDataGrid_PageChanger(Source As Object, E As DataGridPageChangedEventArgs)
   BindData()
 End Sub
 </script>
 <style>
   .DataGrid {font:x-small Verdana, Arial, sans-serif}
 </style>
</head>
<body>
<form runat="server" method="post">
<asp:DataGrid runat="server" id="myDataGrid"
  Border="0"
  Cellpadding="4"
  Cellspacing="0"
  AlternatingItemStyle-BackColor="#EFEFEF"
  ShowHeader="True"
  CssClass="DataGrid"
  HeaderStyle-BackColor="Black"
  HeaderStyle-ForeColor="White"
  HeaderStyle-Font-Bold="True"
  AllowPaging="True"
  PageSize="10"
  PagerStyle-Mode="NextPrev"
  PagerStyle-NextPageText="Next -&gt;"
  PagerStyle-PrevPageText="&lt;- Previous"
  PagerStyle-Font-Bold="True"
  OnPageIndexChanged="myDataGrid_PageChanger"
  />
</form>
</body>
</html>