using System;
using System.Data;
using System.Data.SqlClient;

namespace HasSchemaChangedExample
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		static void Main(string[] args)
		{
			// Create a connection object
			SqlConnection dbConn = new SqlConnection("server=localhost;uid=sa;pwd=;database=WroxDB");

			// Create a DataAdapter
			SqlDataAdapter da = new SqlDataAdapter("SELECT AuthorID, Author_FirstName, Author_LastName FROM tabAuthors", dbConn);

			// Create a DataSet
			AuthorsDataSet dsAuthors = new AuthorsDataSet();

			// Fill the DataSet
			da.Fill(dsAuthors);

			// Add a table
			dsAuthors.Tables.Add(new DataTable());

			// Print to video
			Console.WriteLine(dsAuthors.SchemaChanged().ToString());
		}

		// Derive a new class in order to use the HasSchemaChanged() method
		public class AuthorsDataSet : System.Data.DataSet
		{
			public bool SchemaChanged()
			{
				return this.HasSchemaChanged();
			}

		}
	}
}
