<%@ Page language="c#" Codebehind="CustomerOrderDataGrid.aspx.cs" Inherits="DayOfDotNet.CustomerOrderDataGrid" EnableViewState="False" %>
<HTML>
<body style="font: x-small Verdana, Arial, sans-serif;">
<!-- Begin Web Form -->
<form id="CustomerOrderDataGrid" method="post" runat="server">
	<p><a href="/ADayOfDotNet/">Parent Directory</a></p>

	<!-- Begin DataGrid -->
	<asp:DataGrid id="CustomerDataGrid" runat="server" 
		AutoGenerateColumns="False" 
		CellPadding="2" CellSpacing="0" 
		Font-Names="Verdana, Arial, sans-serif" 
		BorderColor="Black" BorderWidth="1" 
		GridLines="Horizontal" 
		OnItemDataBound="CustomerDataGrid_OnItemDataBound">
		
		<HeaderStyle 
			Font-Bold="True" Font-Size="small" 
			Font-Name="Arial" 
			BackColor="Maroon" ForeColor="White" />
			
		<ItemStyle Font-Size="x-small" />

		<AlternatingItemStyle BackColor="Tan" />

		<Columns>
			<asp:BoundColumn 
				DataField="CustomerID"
				Visible="False" />
				
			<asp:HyperLinkColumn
				DataTextField="CustomerID"
				DataNavigateUrlField="CustomerID"
				DataNavigateUrlFormatString="OrderDetailDataGrid.aspx?customerid={0}"
				HeaderText="ID"
				ItemStyle-VerticalAlign="Top" />
			
			<asp:TemplateColumn ItemStyle-VerticalAlign="Top" HeaderText="Customer">
				<ItemTemplate>
					<b><%# DataBinder.Eval(Container.DataItem, "CompanyName") %></b><br>
					<%# DataBinder.Eval(Container.DataItem, "Address" ) %><br>
					<%# DataBinder.Eval(Container.DataItem, "City" ) %>,
					<%# DataBinder.Eval(Container.DataItem, "Region") %>
					<%# DataBinder.Eval(Container.DataItem, "PostalCode" ) %><br>
					<br>
					<%# DataBinder.Eval(Container.DataItem, "ContactName" ) %><br>
					<%# DataBinder.Eval(Container.DataItem, "ContactTitle" ) %><br>
					<%# DataBinder.Eval(Container.DataItem, "Phone" ) %>
				</ItemTemplate>
			</asp:TemplateColumn>

			<asp:TemplateColumn ItemStyle-VerticalAlign="Top" 
				HeaderText="Orders">			
				<%-- Embedded DataGrid will go here --%>
			</asp:TemplateColumn>			
		</Columns>
	</asp:DataGrid>
	<!-- End DataGrid -->
</form>
<!-- End Web Form -->
</body>
</HTML>
