Imports System
Imports System.Data
Imports System.Drawing
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.HtmlControls

Namespace DayOfDotNet

	Public Class SortingDataGrid1
		Inherits System.Web.UI.Page

		Protected DataGrid1 As DataGrid

		Private Sub Page_Load(sender As object, e As System.EventArgs)
			If Not Page.IsPostBack Then
				'On the first request, Bind the DataGrid
				BindData(Nothing)
			End If
		End Sub

		Private Sub BindData(_sortExpression As String)
			'Create the DataView and cache it to improvwe performance
			'BooksData _booksData = New BooksData();
			Dim _booksData As BooksData = New BooksData()
			Dim _data As DataView = _booksData.GetAllBooks()
			
			'If the _sortExpression has a value, sort the
			'DataView, otherwise just bind the DataGrid
			If Not _sortExpression = Nothing Then
				_data.Sort = _sortExpression
			End If
			
			'Bind the DataGrid
			DataGrid1.DataSource = _data
			DataGrid1.DataBind()
		End Sub
		
		Protected Sub SortCommand_OnClick(sender As object, e As DataGridSortCommandEventArgs)
			'When a sort link is clicked, bind the 
			'DataGrid using the SortExpression
			BindData(e.SortExpression)
		End Sub
	End Class
End Namespace