using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Data.SqlClient;
using System.Text.RegularExpressions;

namespace PowerOfDotNet.Clubs.Board
{
	/// <summary>
	/// GetClubHTMLContent   Դϴ.
	/// </summary>
	public class GetClubHTMLContent : System.Web.UI.Page
	{
		protected Label lblContent;

		private void Page_Load(object sender, System.EventArgs e)
		{
			int intPID = Convert.ToInt32(Request.Params["PID"]);
			string tableName = Request.Params["Table"].ToString();

			PowerOfDotNet.Components.BoardClubDB oDb = new PowerOfDotNet.Components.BoardClubDB();

			SqlDataReader sdr = oDb.GetContent(tableName, intPID);
			sdr.Read();
			lblContent.Text = ConvertToDBLink(sdr.GetString(3), intPID, tableName);
		}

		private string ConvertToDBLink(string content, int PID, string tableName)
		{
			Regex ContentRegex = new Regex(@"\${2}(?<filename>[^\$]+)\${2}");

			Match m = ContentRegex.Match(content);

			if ( m.Success ) 
			{
				string retContent = ContentRegex.Replace(content ,"GetClubImage.ashx?PID=" + PID + "&Table=" + tableName + "&FileName=${filename}&bypass=true");
				return retContent;
			} 
			else 
			{
				return content;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion
	}
}
