using System;
using System.Data;
using System.Data.SqlClient;
using System.Data.Common;
using System.Web.UI.WebControls;
using System.Configuration;

namespace Chapter19
{
	public class ParentChild : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.DataGrid datgrdParent;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				datgrdParent.DataSource = GetParentData();
				datgrdParent.DataBind();
			}
		}

		private SqlDataReader GetParentData()
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2";
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		private SqlDataReader GetChildData(int prodId)
		{
			string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
			string strQuery = "select * from tbDataPresentation2_Orders " + 
						"where prodId=" + prodId;
			SqlConnection sqlConn = new SqlConnection(strSqlConn);
			SqlCommand cmdSql = new SqlCommand(strQuery, sqlConn);

			sqlConn.Open();
			SqlDataReader dr = cmdSql.ExecuteReader(CommandBehavior.CloseConnection);

			return dr;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			InitializeComponent();
			base.OnInit(e);
		}
		
		private void InitializeComponent()
		{    
			this.datgrdParent.ItemCreated += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdParent_ItemCreated);
			this.datgrdParent.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdParent_ItemDataBound);
			this.Load += new System.EventHandler(this.Page_Load);
		}
		#endregion

		private void datgrdParent_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				DataGrid dgParent = ((DataGrid)sender);
				int id = (int)dgParent.DataKeys[e.Item.ItemIndex];
				DataGrid dgChild = (DataGrid)e.Item.Cells[1].FindControl("datgrdChild");

				dgChild.DataSource = GetChildData(id);
				dgChild.DataBind();
				//dgChild_SelectedIndexChanged  
				dgChild.Attributes["parentId"] = id.ToString();
			}
		}

		private void dgChild_ItemDataBound(object sender, DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				//e.Item.DataItem Ÿ ˾Ƴ 
				//e.Item.Cells[3].Text = date;
				//Response.Write(e.Item.DataItem.GetType().ToString() + "<br>");
				DbDataRecord dataRecord = (DbDataRecord)e.Item.DataItem;
				string date = ((DateTime)dataRecord["purchaseDate"]).ToString("yyyy-MM-dd");
			}
		}

		private void dgChild_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			DataGrid dg = ((DataGrid)sender);

			//θ DataGrid IDϴ ΰ 
			DataGridItem dgItem  = (DataGridItem)((TableCell)dg.Parent).Parent;
			int parentId = (int)datgrdParent.DataKeys[dgItem.ItemIndex];
			//Ǵ
			//string parentId = dg.Attributes["parentId"];

			Response.Write(" : datgrdParent ID=" + parentId + 
							", datgrdChild ε=" + dg.SelectedIndex + 
							", datgrdChild ID=" + dg.DataKeys[dg.SelectedIndex] +
							"<br>");
		}

		private void datgrdParent_ItemCreated(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if (e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				DataGrid dgChild = (DataGrid)e.Item.Cells[1].FindControl("datgrdChild");
				dgChild.ItemDataBound += new DataGridItemEventHandler(this.dgChild_ItemDataBound);
				dgChild.SelectedIndexChanged += new EventHandler(dgChild_SelectedIndexChanged);
			}
		}
	}
}
