<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Data.Common" %>
<HTML>
	<script language="C#" runat="server">
	public ICollection GetData()
	{
		string strSqlConn = ConfigurationSettings.AppSettings["SqlConnectionString"];
		string strQuery = "select * from tbDataPresentation2";
		SqlConnection sqlConn = new SqlConnection(strSqlConn);
		SqlDataAdapter da = new SqlDataAdapter(strQuery, sqlConn);

		DataSet ds = new DataSet();
		da.Fill(ds, "DataPresentation2");
		return ds.Tables["DataPresentation2"].DefaultView;
	}

	void Page_Load(Object sender, EventArgs e) 
	{
		DataGrid1.DataSource = GetData();
		DataGrid1.DataBind();
	}

	void Item_Bound(Object sender, DataGridItemEventArgs e) 
	{
		if (e.Item.ItemType == ListItemType.Item)
		{
			e.Item.Cells[0].Text = "<b><i>" + e.Item.Cells[0].Text + "</i></b>";
			
			DataRowView dr = (DataRowView)e.Item.DataItem;
			Button btn = new Button();
			btn.Text = "ID:" + dr["id"].ToString();
			btn.CommandName = "ItemCommand";
			e.Item.Cells[1].Controls.Add(btn);
		}
		else if (e.Item.ItemType == ListItemType.AlternatingItem)
		{
			LinkButton lbtn = new LinkButton();
			lbtn.CommandName = "AlternatingItemCommand";
			lbtn.Text = "";
			e.Item.Cells[1].Controls.Add(lbtn);
			/**************************************************
			GetPostBackClientHyperlink ޼ҵ ݵ
			LinkButton ü Cell ߰ Ŀ ȣϿѴ.
			׷  ItemCommand ̺Ʈ ߻ ʴ´.
			***************************************************/
			
			//콺 ո ǵѴ.
			e.Item.Cells[0].Style["cursor"] = "hand";
			// ũϸ ư ̺Ʈ ߻ϵ Ѵ.
			e.Item.Cells[0].Attributes["onclick"] = 
				Page.GetPostBackClientHyperlink(lbtn, "");
			//콺 (<td>)    Ե 
			//  ǵ Ѵ.
			//parentElement  Ե (<tr>) ̴.
			e.Item.Cells[0].Attributes["onmouseover"] = 
				"this.parentElement.style.backgroundColor='#FFDCD4'";
			//콺     ǵ Ѵ.
			e.Item.Cells[0].Attributes["onmouseout"] = 
				"this.parentElement.style.backgroundColor='white'";
				
			e.Item.Cells[1].Style["cursor"] = "hand";
			e.Item.Cells[1].Attributes["onclick"] = 
				Page.GetPostBackClientHyperlink(lbtn, "");
			e.Item.Cells[1].Attributes["onmouseover"] = 
				"this.parentElement.style.backgroundColor='#FFDCD4'";
			e.Item.Cells[1].Attributes["onmouseout"] = 
				"this.parentElement.style.backgroundColor='white'";
		}
	}
	
	void Item_Command(Object sender, DataGridCommandEventArgs e) 
	{
		Response.Write("CommandName = " + e.CommandName + 
			", Index = " + e.Item.ItemIndex);
	}

	</script>
	<BODY>
		<form method="post" runat="server">
			<asp:datagrid id="DataGrid1" runat="server" AutoGenerateColumns="False" OnItemDataBound="Item_Bound" OnItemCommand="Item_Command" AllowPaging="true" PageSize="4">
				<HeaderStyle BackColor="#00AAAA"></HeaderStyle>
				<PagerStyle BackColor="#00AAAA"></PagerStyle>
				<Columns>
					<asp:BoundColumn DataField="title" HeaderText=""></asp:BoundColumn>
					<asp:TemplateColumn HeaderText="">
						<ItemTemplate>
							:
							<%# DataBinder.Eval(Container.DataItem, "author" ) %>
						</ItemTemplate>
					</asp:TemplateColumn>
				</Columns>
			</asp:datagrid>
		</form>
	</BODY>
</HTML>
