using System;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.ComponentModel;

namespace CustomControls.Ex09
{
	public class Ex09_Control : Control, INamingContainer
	{
		public event EventHandler AddCalculated;
		public event EventHandler SubCalculated;

		public int Result {
			get	{
				EnsureChildControls();
				string val = ((LiteralControl)Controls[5]).Text;
				return int.Parse(val);
			}
			set	{
				EnsureChildControls();
				((LiteralControl)Controls[5]).Text = value.ToString();
			}
		}

		protected override void CreateChildControls()
		{
			Controls.Add(new LiteralControl("<h3>ϱ/ Ʈ</h3>"));

			DropDownList ddl1 = new DropDownList();
			for (int i=0;i<20;i++)
				ddl1.Items.Add(i.ToString());
			ddl1.SelectedIndex = 0;
			Controls.Add(ddl1);

			Controls.Add(new LiteralControl(" + | - "));

			DropDownList ddl2 = new DropDownList();
			for (int i=0;i<20;i++)
				ddl2.Items.Add(i.ToString());
			ddl2.SelectedIndex = 0;
			Controls.Add(ddl2);

			Controls.Add(new LiteralControl(" = "));

			//  
			Controls.Add(new LiteralControl("0"));

			Controls.Add(new LiteralControl("<br><br>"));

			Button btnAdd = new Button();
			btnAdd.Text = "ϱ";
			btnAdd.Click += new EventHandler(this.btnAdd_Click);
			Controls.Add(btnAdd);

			Button btnSub = new Button();
			btnSub.Text = "";
			btnSub.Click += new EventHandler(this.btnSub_Click);
			Controls.Add(btnSub);
		}

		private void btnAdd_Click(Object sender, EventArgs e) 
		{
			DropDownList ddl1 = (DropDownList)Controls[1];
			DropDownList ddl2 = (DropDownList)Controls[3];
			Result = ddl1.SelectedIndex + ddl2.SelectedIndex;

			if (AddCalculated != null)
				AddCalculated(this, EventArgs.Empty);
		}

		private void btnSub_Click(Object sender, EventArgs e) 
		{
			DropDownList ddl1 = (DropDownList)Controls[1];
			DropDownList ddl2 = (DropDownList)Controls[3];
			Result = ddl1.SelectedIndex - ddl2.SelectedIndex;

			if (SubCalculated != null)
				SubCalculated(this, EventArgs.Empty);
		}
	}
}