namespace PowerOfDotNet.WebMail
{
	using System;
	using System.Collections;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///		ReceptionCheck   Դϴ.
	/// </summary>
	public abstract class ReceptionCheck : PowerOfDotNet.PortalModuleControl
	{
		protected System.Web.UI.WebControls.Button btnDelete;
		protected System.Web.UI.WebControls.DataGrid datgrdReceptionCheck;

		private int registerArrayCount = 0;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				BindData();
			}

			if (!Page.IsStartupScriptRegistered("_receptionSetChkboxAllSelectObj"))
			{
				string setChkboxAllSelectObj = @"
<script language=javascript>
<!--
	checkAllBox = document.getElementById('chkboxAllReceptionSelect');
//-->
</script>
				";
				Page.RegisterStartupScript("_receptionSetChkboxAllSelectObj", setChkboxAllSelectObj);
			}
		}

		private void BindData()
		{
			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			DataSet ds = db.GetReceptionCheckList(this.Page.User.Identity.Name);
			datgrdReceptionCheck.DataSource = ds.Tables[0].DefaultView;
			datgrdReceptionCheck.DataBind();
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.datgrdReceptionCheck.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdReceptionCheck_PageIndexChanged);
			this.datgrdReceptionCheck.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdReceptionCheck_ItemDataBound);
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			foreach (DataGridItem item in datgrdReceptionCheck.Items)
			{
				if (((CheckBox)item.Cells[1].FindControl("chkboxCheck")).Checked)
				{
					db.DeleteReception(Convert.ToInt32(item.Cells[0].Text));
				}
			}
			datgrdReceptionCheck.CurrentPageIndex = 0;
			BindData();
		}

		private void datgrdReceptionCheck_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((DataGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();	
		}

		private void datgrdReceptionCheck_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem)
			{
				if (((ICollection)((DataGrid)sender).DataSource).Count > registerArrayCount)
				{
					CheckBox oc = (CheckBox)e.Item.Cells[1].FindControl("chkboxCheck");
					oc.Attributes["onclick"] = "__webmailReceptionSetCheckAllBox()";
					this.Page.RegisterArrayDeclaration("__WebmailReceptionCheckBoxArr", "document.getElementById(\"" + oc.ClientID + "\")");
					registerArrayCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}
	}
}
