use dbMall

GO
CREATE DEFAULT UW_ZeroDefault AS 0

GO
/*  */
CREATE TABLE [dboMall].[customer] (
	[no] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ID] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ID */
	[Password] [char] (12) COLLATE Korean_Wansung_CI_AS NOT NULL , /* йȣ */
	[Name] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL , /*  */
	[Gender] [bit] NOT NULL , /* .  - 1,  - 0 */
	[Joomin1] [char] (6) NOT NULL , /* ֹεϹȣ ڸ */
	[Joomin2] [char] (7) NOT NULL , /* ֹεϹȣ ڸ */
	[Email] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL , /* E-Mail */
	[Phone] [char] (20) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ȭȣ */
	[HPhone] [char] (20) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ڵ */
	[Zip1] [char] (3) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ȣ  */
	[Zip2] [char] (3) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ȣ  */
	[Address1] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ּ  */
	[Address2] [varchar] (100) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ּ  */
	[Introduction] [text] COLLATE Korean_Wansung_CI_AS NOT NULL , /* Ұ  ϰ  */
	[Preference] [tinyint] NOT NULL , /* Ϲȸ - 0, ȸ - 1 */
	[RecommendationCount] [int] NULL , /* Ⱥ õ */
	[Accumulation] [bigint] NULL , /* ݾ */
	[PurchasedTotal] [bigint] NULL , /*  űݾ */
	[RegDate] [datetime] NOT NULL , /*  */
	[LastLogonDate] [datetime] NOT NULL , /*  α׿  */
	[LoginCount] [int] NULL  /* αȸ */
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO
/* 1ܰ ī */
CREATE TABLE [dboMall].[category_top] (
	[t_no] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[SortOrder] [int] NULL ,
	[ImageName] [varchar] (30) NULL ,
	[ImageNameMenu] [varchar] (30) NULL /* ޴ ̹ */
) ON [PRIMARY]

GO
/* 2ܰ ī */
CREATE TABLE [dboMall].[category_index] (
	[i_no] [int] IDENTITY (1, 1) NOT NULL ,
	[t_no] [int] NOT NULL , /* 1ܰ ī ȣ */
	[SortOrder] [int] NULL , /* 2ܰ谡 1ܰȿ ĵǴ  */
	[Name] [varchar] (20) COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[ImageName] [varchar] (30) NULL ,
	[ImageNameMenu] [varchar] (30) NULL /* ޴ ̹ */
) ON [PRIMARY]

GO
/* ǰ  */
CREATE TABLE [dboMall].[products] (
	[p_no] [bigint] IDENTITY (1, 1) NOT NULL , /* ȣ */
	[i_no] [int] NOT NULL , /* 2ܰ ī ȣ */
	[Name] [varchar] (40) COLLATE Korean_Wansung_CI_AS NULL ,
	[Model] [varchar] (10)  NULL , /*  no */
	[Description] [text] COLLATE Korean_Wansung_CI_AS NULL , /* Ұ */
	[Price] [bigint] NOT NULL , /*  */
	[PriceDiscount] [bigint] NULL , /*  . NULL ̳ 0 ̸  */
	[Recommendation] [tinyint] NULL , /* õ ǰ.  Żǰ - 1, õ - 2, ƴϸ - 0 */
	[Pool] [varchar] (50) COLLATE Korean_Wansung_CI_AS NULL , /* ó */
	[ImagegS] [varchar] (30)  NULL , /* ̹  */
	[ImagegM] [varchar] (30)  NULL , /* ̹  */
	[ImagegL] [varchar] (30)  NULL , /* ̹  */
	[Absence] [tinyint] NULL , /* ǰ - 1, ƴϸ - 0 */
	[Class] [int] NULL , /* ǰ  ȣ .  ǰ - 0 */
	[Quantity] [int]  NULL , /*  */
	[DateAdded] [datetime] NOT NULL , /*  */
	[Sell] [int] NULL , /* ǸŰԼ */
	[Viewed] [int] NULL  /* ȸ */
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

/* ٱ */
CREATE TABLE [dboMall].[basket] (
	[no] [bigint] IDENTITY (1, 1) NOT NULL ,
	[p_no] [bigint] NULL , /* ǰȣ */
	[ID] [char] (10) COLLATE Korean_Wansung_CI_AS NULL ,
	[Count] [int] NOT NULL , /* Լ */
	[DateAdded] [datetime] NOT NULL  /* ٱϿ   */
) ON [PRIMARY]
GO

/*  - ϵ ȸ   ִ.*/
CREATE TABLE [dboMall].[reviews] (
	[no] [bigint] IDENTITY (1, 1) NOT NULL , /* ƮҶ  ʵ ؼ ش. */
	[ID] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ۾ ID */
	[Name] [char] (10) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ۾ ̸ */
	[p_no] [bigint] NOT NULL , /* ǰ ȣ */
	[Score] [tinyint] NULL , /* .  鼭 ̶    ִ. */
	[Content] [text] COLLATE Korean_Wansung_CI_AS NOT NULL ,
	[WriteDate] [datetime] NOT NULL
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]
GO


/* ֹ - ȸ  ִ. */
CREATE TABLE [dboMall].[orders] (
	[o_no] [bigint] IDENTITY (1, 1) NOT NULL ,
	[ID] [char] (10) COLLATE Korean_Wansung_CI_AS NULL , /*  ID. ȸ 츸 ϵȴ. ƴϸ NULL  */
	[Name] [varchar] (10) COLLATE Korean_Wansung_CI_AS NOT NULL , /*   */
	[p_no] [bigint] NOT NULL , /* ǰ ȣ */
	[Preference] [tinyint] NULL , /* Ϲȸ - 0, ȸ - 1, ƴϸ - NULL */
	[Email] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,  /* Email */
	[Phone] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL ,  /* ȭ */
	[HPhone] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ڵ */
	[Zip1] [char] (3) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ȣ 1 */
	[Zip2] [char] (3) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ȣ 2 */
	[Address] [varchar] (200) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ּ 1 */
	[Address2] [varchar] (100) COLLATE Korean_Wansung_CI_AS NULL , /* ּ 2 */
	[Note] [text] COLLATE Korean_Wansung_CI_AS NULL , /*  ޸ */
	[Baedal] [bit] NOT NULL , /*   */
	[BaedalDate] [datetime] NULL , /*   */
	[OrderDate] [datetime] NULL , /* ֹ  */
	[PaymenyMethod] [tinyint] NOT NULL , /* .  ī  - 1,  Ա - 0 */
	[PayName] [varchar] (10) , /* Ա , ī  ī */
	[Bank] [int]  NULL , /* Ա ȣ(no). Bank ̺ Ѵ. */
	[ExpectationDateY] [char] (4) NULL , /* Ա  -  */
	[ExpectationDateM] [char] (2) NULL , /* Ա  -  */
	[ExpectationDateD] [char] (3) NULL , /* Ա  -  */
	[Receipt] [bit] NOT NULL , /* Ա . ԱݿϷ - 1, ̴ϸ - 0 */
	[CardNumber] [varchar] (20) NULL , /* ī ȣ */
	[CardExpires] [varchar] (4) NULL , /* ī  */
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO
/* ֹ ǰ */
CREATE TABLE [dboMall].[orders_product] (
	[no] [bigint] IDENTITY (1, 1) NOT NULL ,
	[o_no] [bigint]  NOT NULL , /* ֹ ȣ */
	[p_no] [bigint] NOT NULL , /* ǰ ȣ */
	[Name] [varchar] (50) COLLATE Korean_Wansung_CI_AS NOT NULL , /* ǰ */
	[Price] [bigint] NOT NULL , /*  */
	[Count] [int] NOT NULL  /* ǰ Լ */
) ON [PRIMARY]

GO
/*  Ʈ */
CREATE TABLE [dboMall].[Bank] (
	[no] [int] IDENTITY (1, 1) NOT NULL ,
	[Name] [varchar] (70) COLLATE Korean_Wansung_CI_AS NOT NULL , /*  ̸ */
) ON [PRIMARY]

GO
/*  ȣ */
CREATE TABLE [dboMall].[zip] (
	[ID] [int] NOT NULL ,
	[ZIPCODE] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[s1] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[s2] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[s3] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[s4] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL ,
	[s5] [nvarchar] (255) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

CREATE TABLE [dboMall].[admin_id] (
	[no] [int] NOT NULL ,
	[id] [char] (10) COLLATE Korean_Wansung_CI_AS NULL ,
	[pwd] [char] (10) COLLATE Korean_Wansung_CI_AS NULL ,
	[cont] [char] (100) COLLATE Korean_Wansung_CI_AS NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dboMall].[category_index] WITH NOCHECK ADD 
	CONSTRAINT [PK_Category_index] PRIMARY KEY CLUSTERED
	(
		[i_no]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dboMall].[products] WITH NOCHECK ADD
	CONSTRAINT [PK_Products] PRIMARY KEY CLUSTERED
	(
		[p_no]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dboMall].[basket] WITH NOCHECK ADD 
	CONSTRAINT [PK_basket] PRIMARY KEY  CLUSTERED 
	(
		[no]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dboMall].[reviews] WITH NOCHECK ADD 
	CONSTRAINT [PK_Reviews] PRIMARY KEY  CLUSTERED 
	(
		[no]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dboMall].[orders] WITH NOCHECK ADD 
	CONSTRAINT [PK_orders] PRIMARY KEY  CLUSTERED 
	(
		[o_no]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dboMall].[customer] WITH NOCHECK ADD
	CONSTRAINT [DF_Customer_Preference] DEFAULT (0) FOR [Preference], /* Ϲȸ */
	CONSTRAINT [DF_Customer_RecommendationCount] DEFAULT (0) FOR [RecommendationCount],
	CONSTRAINT [DF_Customer_Accumulation] DEFAULT (0) FOR [Accumulation],
	CONSTRAINT [DF_Customer_PurchasedTotal] DEFAULT (0) FOR [PurchasedTotal],
	CONSTRAINT [DF_Customer_LoginCount] DEFAULT (0) FOR [LoginCount]
GO

ALTER TABLE [dboMall].[category_top] WITH NOCHECK ADD
	CONSTRAINT [DF_Category_top_SortOrder] DEFAULT (1) FOR [SortOrder]
GO

ALTER TABLE [dboMall].[category_index] WITH NOCHECK ADD
	CONSTRAINT [DF_Category_index_SortOrder] DEFAULT (1) FOR [SortOrder]
GO


ALTER TABLE [dboMall].[products] WITH NOCHECK ADD 
	CONSTRAINT [DF_Products_PriceDiscount] DEFAULT (0) FOR [PriceDiscount],
	CONSTRAINT [DF_Products_Recommendation] DEFAULT (0) FOR [Recommendation], /* Ϲǰ */
	CONSTRAINT [DF_Products_Absence] DEFAULT (0) FOR [Absence], /* ǰƴ */
	CONSTRAINT [DF_Products_Quantity] DEFAULT (0) FOR [Quantity],
	CONSTRAINT [DF_Products_Class] DEFAULT (0) FOR [Class], /*  ǰ  */
	CONSTRAINT [DF_Products_Sell] DEFAULT (0) FOR [Sell], 
	CONSTRAINT [DF_Products_Viewed] DEFAULT (0) FOR [Viewed]
GO

ALTER TABLE [dboMall].[orders] WITH NOCHECK ADD 
	CONSTRAINT [DF_Orders_Preference] DEFAULT (0) FOR [Preference], /* Ϲȸ */
	CONSTRAINT [DF_Orders_Baedal] DEFAULT (0) FOR [Baedal], /* ޾ʵ */
	CONSTRAINT [DF_Orders_Receipt] DEFAULT (0) FOR [Receipt] /* Աݾʵ */
GO


CREATE  INDEX [IX_reviews_t_no_SortOrder] ON [dboMall].[category_index]([t_no], [SortOrder]) ON [PRIMARY]
GO

CREATE  INDEX [IX_category_index_p_no_WriteDate] ON [dboMall].[reviews]([p_no], [WriteDate]) ON [PRIMARY]
GO

CREATE  INDEX [IX_Orders_product_o_no] ON [dboMall].[orders_product]([o_no]) ON [PRIMARY]

