/*
 * 2004 2 20 
 * */

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using System.Configuration;

namespace PowerOfDotNet.Clubs
{
	/// <summary>
	/// UserJoinInfoModify   Դϴ.
	/// </summary>
	public class UserJoinInfoModify : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblClubSubject;
		protected System.Web.UI.WebControls.Label lblUserName;
		protected System.Web.UI.WebControls.TextBox txtSelfIntroduction;
		protected System.Web.UI.WebControls.Button btnModify;
		protected System.Web.UI.WebControls.CheckBoxList chkboxlstOpenInfo;

		private int _clubId;
		private string _openerUri;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			_clubId = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["clubId"], -1);
			_openerUri = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["openerUri"], "").Replace("^","=").Replace("$","&");
			if (!IsPostBack)
			{
				string userId = this.Page.User.Identity.Name;
				PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();

				lblUserName.Text = Request.Cookies["usersInfo"]["Name"].ToString();
				SqlDataReader drClub = db.GetClub(_clubId);
				drClub.Read();
				lblClubSubject.Text = drClub["Subject"].ToString();
				this.ViewState["PublicType"] = (byte)drClub["PublicType"];
				drClub.Close();

				SqlDataReader sdr = db.GetClubUserInfo(_clubId, userId);
				sdr.Read();
				string openInfo = sdr["OpenInformations"].ToString();

				string[] aOpenInfos = ConfigurationSettings.AppSettings["ClubUserOpenInformations"].Split(new char[] {';'});
				string[] aUserOpens = openInfo.Split(new char[] {';'});

				foreach (string opName in aOpenInfos)
				{
					string[] aFieldInfo = opName.Split(new char[] {'='});
					ListItem item = new ListItem(aFieldInfo[0]);

					foreach (string openedName in aUserOpens)
						if (openedName == aFieldInfo[0])
							item.Selected = true;

					chkboxlstOpenInfo.Items.Add(item);
				}

				txtSelfIntroduction.Text = sdr["SelfIntroduction"].ToString();
				sdr.Close();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// ̳  ʿ ޼Դϴ.
		///  ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnModify.Click += new System.EventHandler(this.btnModify_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnModify_Click(object sender, System.EventArgs e)
		{
			string openInfo = String.Empty;
			foreach (ListItem item in chkboxlstOpenInfo.Items)
			{
				if (item.Selected)
				{
					if (openInfo == String.Empty)
						openInfo += item.Text;
					else
						openInfo += ";" + item.Text;
				}
			}

			PowerOfDotNet.Components.ClubsDB db = new PowerOfDotNet.Components.ClubsDB();
			db.UpdateMemberInfo(_clubId, this.Page.User.Identity.Name, txtSelfIntroduction.Text, openInfo);

			MyWebLibs.Utilities.CommonMethods.PrintMsgAndCloseAndOpenerRedir("Ǿϴ.", _openerUri);
		}
	}
}
