/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.Home
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using System.Collections;
	using MyWebLibs.Utilities;

	/// <summary>
	///		FragBoard1   Դϴ.
	/// </summary>
	public abstract class FragBoard1 : PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.HyperLink hyplnkMore;
		protected System.Web.UI.WebControls.DataList datlstSkinBoard;
		protected System.Web.UI.WebControls.Label lblSubject;
		protected DesktopModuleTitle DesktopModuleTitle1;

		private bool _openWindowAtStart = false;

		private string _openFragBoardChaildWin = @"
<script language=""javascript"">
<!--
function OpenFragBoardChailWin(parm, windowName)
{{
	var uri = ""{0}?bypass=true"" + parm;
	var childWin = window.open(uri, windowName, 
		""height=450,width=400,toolbar=no,menubar=no,location=no,status=no,resizable=yes"");

	childWin.opener = window;
	childWin.focus();
}}
//-->
</script>
		";

		private void Page_Load(object sender, System.EventArgs e)
		{
			PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
			SqlDataReader dr = db.GetFragBoardSetting(this.ModuleId);
			if (dr.Read()) {
				Components.BoardLactureInfo blInfo = null;
				int boardId = 0;
				int fragBoardType = (int)(byte)dr["fragBoardType"];
				string[] aTemplates = new String[] {
							"~/Home/FragBoardTemplate1.ascx", 
							"~/Home/FragBoardTemplate2.ascx", 
							"~/Home/FragBoardTemplate3.ascx"
						};

				datlstSkinBoard.ItemTemplate = 
					Page.LoadTemplate(aTemplates[fragBoardType]);

				boardId = (int)dr["bbsId"];
				blInfo = (Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
				if (blInfo == null) {
					blInfo = db.GetBoardInfo(boardId);
					this.SetObjectToCache("BoardLactureTableInfo" + boardId, blInfo, 30);
				}
				lblSubject.Text = blInfo.BBSSubject;

				// ۵ɶ ڽâ 
				_openWindowAtStart = fragBoardType == 0 && (bool)dr["openWindowAtStart"];
				dr.Close();
				if (_openWindowAtStart && 
					Request.Cookies["openWindowAtStart" + this.ModuleId] == null) {
					Response.Cookies["openWindowAtStart" + this.ModuleId].Value = "opened";
				}
				else
					_openWindowAtStart = false;

				datlstSkinBoard.DataSource = CtrateDataSource(boardId, fragBoardType, blInfo);
				//datlstSkinBoard.DataBind();
				this.DataBind();

				hyplnkMore.NavigateUrl = GetLink(blInfo.BBSPageNameList);

				if (!Page.IsClientScriptBlockRegistered("_openFragBoardChaildWin")) {
					_openFragBoardChaildWin = String.Format(
						_openFragBoardChaildWin, 
						CommonMethods.RealImagePath("~/home/FragBoardChaild.aspx"));
					Page.RegisterClientScriptBlock("_openFragBoardChaildWin", _openFragBoardChaildWin);
				}
			}
			else {
				lblSubject.Text = "⿡    ʾҽϴ.";
				lblSubject.ForeColor = Color.Red;
				this.DataBind();
			}

			DesktopModuleTitle1.EditUrl = "~/Home/Admin/EditFragBoard.aspx?mcKey=" + this.CacheKey;
		}

		private ICollection CtrateDataSource(int boardId, int fragBoardType, Components.BoardLactureInfo blInfo)
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("Writer", typeof(string)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));
			dt.Columns.Add(new DataColumn("IsNew", typeof(bool)));
			dt.Columns.Add(new DataColumn("Link", typeof(string)));
			dt.Columns.Add(new DataColumn("Content", typeof(string)));

			PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
			SqlDataReader sdr = db.GetSqlRecentSubject(blInfo.BBSTable, 7);

			while (sdr.Read()) 
			{
				dr = dt.NewRow();

				dr[0] = sdr["ID"]; //ID
				string subject = sdr["Subject"].ToString();//Subject
				int treeId = (int)sdr["TreeID"]; //TreeID
				for (int i=0;i<treeId;i++)
					subject = "&nbsp;&nbsp;&nbsp;" + subject;

				dr[1] = subject;
				dr[2] = sdr["Writer"]; //Writer
				DateTime regDate = Convert.ToDateTime(sdr["RegDate"]);
				dr[3] = regDate.ToString("yyyy-MM-dd"); //RegDate
				dr[4] = regDate >= DateTime.Now.AddDays(-1);//New ̹ ÷ 

				if (fragBoardType == 0)	{
					string parm = "&TableName=" + blInfo.BBSTable + "&id=" + dr["ID"];
					string windowName = "fragChildWin" + this.ModuleId;
					string callChildWin = "OpenFragBoardChailWin(\"" + parm + "\", \"" + windowName + "\")";
					dr[5] = "javascript:" + callChildWin;
					if (_openWindowAtStart)	{
						MyWebLibs.Utilities.CommonMethods.RegisterOnloadFunction(Page, callChildWin);
						_openWindowAtStart = false;
					}
				}
				else
					dr[5] = this.GetLink(blInfo.BBSPageNameContent) + "&TableId=" + boardId + 
						"&page=0&group0=" + sdr["GroupID"] + ":" + dr["ID"];

				string content = sdr["Content"].ToString();
				if ((byte)sdr["Format"] == 1)
					content = Server.HtmlEncode(content);

				if (content.Length > 250)
					content = content.Substring(0,250) + " ...>";

				dr[6] = "<font color=\"#666666\">" + content + "</font>";

				dt.Rows.Add(dr);
			}
			sdr.Close();

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
