/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.NewStudy.DownloadBoard
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using PowerOfDotNet.TypedDataSet;

	/// <summary>
	///		DownloadWrite   Դϴ.
	/// </summary>
	public abstract class DownloadWrite : PowerOfDotNet.PortalModuleControlEx
	{

		//protected System.Web.UI.HtmlControls.HtmlInputText Text1;
		protected System.Web.UI.WebControls.Button btnOk;
		protected System.Web.UI.WebControls.DropDownList ddlistCategory;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnLanguage;
		protected System.Web.UI.WebControls.TextBox txtDescription;
		protected System.Web.UI.HtmlControls.HtmlInputText txtSubject;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator3;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.HtmlControls.HtmlSelect selTarget;
		protected System.Web.UI.HtmlControls.HtmlInputFile filUpload;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//߱Ⱓ 
			//this.RemoveObjectCache("CategoryAspDotNetDS");

			if (!IsPostBack)
			{
				//ViewState["ReturnUri"] = Request.UrlReferrer.AbsolutePath;

				this.Form.Enctype = "multipart/form-data";

				DataSet dsCategory = (DataSet)this.GetObjectFromCache("CategoryAspDotNetDS");
				if (dsCategory == null)
				{
					PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();

					dsCategory = db.CategoryList();
					this.SetObjectToCache("CategoryAspDotNetDS", dsCategory, 30);
				}

				DataView dv = dsCategory.Tables["CategoryAspDotNet"].DefaultView;
				dv.Delete(0); //All ⿡ ̸ ʵȴ.
				ddlistCategory.DataSource = dv;
				ddlistCategory.DataTextField = "anCategory";
				ddlistCategory.DataValueField = "anID";
				ddlistCategory.DataBind();
				ddlistCategory.SelectedIndex = 0;
			}
			else
			{
				Page.Validate();
				if (!Page.IsValid) {
					foreach(IValidator val in Page.Validators) {
						if (!val.IsValid)
							MyWebLibs.Utilities.CommonMethods.PrintMsgBack(val.ErrorMessage);
					}
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnOk_Click(object sender, System.EventArgs e)
		{
			DownloadDS od = (DownloadDS)this.GetObjectFromCache("DownloadDS");

			if (od == null)
			{
				PowerOfDotNet.Components.DownloadDB db = new PowerOfDotNet.Components.DownloadDB();

				od = db.CreateDownloadDS();

				this.SetObjectToCache("DownloadDS", od, 30);
			}

			byte bytCategoryNum = Convert.ToByte(ddlistCategory.SelectedIndex);
			byte bytLanguageNum = Convert.ToByte(rdobtnLanguage.SelectedIndex);
			byte bytTarget = Convert.ToByte(selTarget.SelectedIndex);
			string strDescription = txtDescription.Text;
			string strSubject = txtSubject.Value;

			UsersDB dbUser = new UsersDB();
			SqlDataReader dr = dbUser.GetSingleUser(this.Page.User.Identity.Name);
			dr.Read();
			string userId = this.Page.User.Identity.Name;
			string userName = dr["Name"].ToString();
			dr.Close();

			int before = od.DownloadBoard.Rows.Count;
			PowerOfDotNet.Components.DownloadDB oDB = new PowerOfDotNet.Components.DownloadDB();
			oDB.AddNewUpload(od, filUpload.PostedFile, bytCategoryNum, bytLanguageNum, strDescription, strSubject, userId, userName, bytTarget); 

			int after = od.DownloadBoard.Rows.Count;

			//Ÿ ̉ Ʒ  ʿ ʴ.
			// ɽð  ƴ  ϱ ̴.
			//this.SetObjectToCache("DownloadDS", od, 30);

			Response.Redirect(GetLink("ڷǸƮ"));
			
		}

	}
}
