/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.NewStudy.Lacture
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;
	using MyWebLibs.Utilities;

	/// <summary>
	///		LactureEdit   Դϴ.
	/// </summary>
	public abstract class LactureEdit : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.TextBox txtSubject;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnFormat;
		protected System.Web.UI.WebControls.TextBox txtContent;
		protected System.Web.UI.HtmlControls.HtmlInputFile File1;
		protected System.Web.UI.HtmlControls.HtmlInputFile File2;
		protected System.Web.UI.HtmlControls.HtmlInputFile File3;
		protected System.Web.UI.HtmlControls.HtmlInputFile File4;
		protected System.Web.UI.HtmlControls.HtmlInputFile File5;
		protected System.Web.UI.HtmlControls.HtmlInputFile File6;
		protected System.Web.UI.HtmlControls.HtmlInputFile File7;
		protected System.Web.UI.HtmlControls.HtmlInputFile File8;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndList;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnWriteAndBefore;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator1;
		protected System.Web.UI.WebControls.RequiredFieldValidator RequiredFieldValidator2;
		protected MyWebLibs.ServerControls.MyValidationSummry MyValidationSummry1;
		protected System.Web.UI.WebControls.CheckBox chkBox;
		protected System.Web.UI.WebControls.Panel pnlHeader;
		protected System.Web.UI.WebControls.CheckBox chkboxUseAvatar;
		protected System.Web.UI.WebControls.RadioButtonList rdobtnlstAvatarExp;

		private PowerOfDotNet.Components.BoardLactureInfo _blInfo;

		private void Page_Load(object sender, System.EventArgs e)
		{
			//  ´.
			int boardId = CommonMethods.RequestInt(Request.Params["TableId"], -1);

			//߱Ⱓ  ̷ Ѵ.
			//this.RemoveObjectCache("BoardLactureTableInfo" + boardId);
			//ɽÿ   ´.
			_blInfo = (PowerOfDotNet.Components.BoardLactureInfo)this.GetObjectFromCache("BoardLactureTableInfo" + boardId);
			if (_blInfo == null) {
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				_blInfo = db.GetBoardInfo(boardId);

				this.SetObjectToCache("BoardLactureTableInfo" + boardId, _blInfo, 30);
			}

			if (!IsPostBack) {
				PowerOfDotNet.Components.AvatarDB dbAvatar = new PowerOfDotNet.Components.AvatarDB();
				SqlDataReader drAvatarExp = dbAvatar.GetAvatarExpression();
				rdobtnlstAvatarExp.DataSource = drAvatarExp;
				rdobtnlstAvatarExp.DataTextField = "Description";
				rdobtnlstAvatarExp.DataValueField = "ID";
				rdobtnlstAvatarExp.DataBind();

				ViewState["before"] = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["before"], "").Replace("^","=").Replace("$","&");
				//string tableName = MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["Table"],"");
				//ViewState["TableName"] = tableName;
				ViewState["genParam"] = "page=" + MyWebLibs.Utilities.CommonMethods.RequestStr(Request.Params["page"],"") +
					"TableId=" + boardId;

				int id = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["id"], 0);
				ViewState["id"] = id;
				PowerOfDotNet.Components.BoardLactureDB db = new PowerOfDotNet.Components.BoardLactureDB();
				SqlDataReader dr = db.GetContent(_blInfo.BBSTable, id);
				dr.Read();

				//GET Ķ͸  ۼؼ  
				//Ǹ  ڸ Ѵ.
				bool authority;
				if (PortalSecurity.IsInRoles(_blInfo.BBSRoles))	authority = true;
				else if (_blInfo.BBSType == 0 && dr["UserID"].ToString().Trim() == Page.User.Identity.Name)	authority = true;
				else	authority = false;
				if (!authority) 
					MyWebLibs.Utilities.CommonMethods.PrintMsgBack("  ִ  ϴ.");

				txtContent.Text = dr.GetString(3);
				txtSubject.Text = dr.GetString(1);
				rdobtnFormat.SelectedIndex = dr.GetByte(6);
				chkboxUseAvatar.Checked = dr.GetBoolean(10);
				rdobtnlstAvatarExp.SelectedIndex = (int)dr.GetByte(11);
				dr.Close();

				this.Form.Enctype = "multipart/form-data";
			}
			MyWebLibs.Utilities.CommonMethods.SetFocus(txtContent);
			
			pnlHeader.Style["text-align"] = "center";
			//ŸƲ 
			switch (_blInfo.BBSDisplayType)	{
				case 0 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSSubject));
					pnlHeader.Style["font-size"] = "16px";
					pnlHeader.Style["font-weight"] = "bold";
					break;
				case 1 :
					pnlHeader.Controls.Add(new LiteralControl("<img src='" + _blInfo.BBSImage + "' />"));
					break;
				case 2 :
					pnlHeader.Controls.Add(new LiteralControl(_blInfo.BBSHtml));
					break;
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnWriteAndList.ServerClick += new System.EventHandler(this.btnWriteAndList_ServerClick);
			this.btnWriteAndBefore.ServerClick += new System.EventHandler(this.btnWriteAndBefore_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnWriteAndList_ServerClick(object sender, System.EventArgs e)
		{
			if (Page.IsValid)
			{
				PowerOfDotNet.Components.BoardLactureData oData = MakeDbData();
				bool bPreserve = chkBox.Checked;
				PowerOfDotNet.Components.BoardLactureDB oDb = new PowerOfDotNet.Components.BoardLactureDB();
				oDb.Modify(_blInfo.BBSTable, oData, Request.Files, bPreserve);
				Response.Redirect(GetLink(_blInfo.BBSPageNameList) + "&" + (string)ViewState["genParam"]);
			}
		}

		private void btnWriteAndBefore_ServerClick(object sender, System.EventArgs e)
		{
			if (Page.IsValid)
			{
				PowerOfDotNet.Components.BoardLactureData oData = MakeDbData();
				bool bPreserve = chkBox.Checked;
				PowerOfDotNet.Components.BoardLactureDB oDb = new PowerOfDotNet.Components.BoardLactureDB();
				oDb.Modify(_blInfo.BBSTable, oData, Request.Files, bPreserve);
				Response.Redirect((string)ViewState["before"]);
			}
		}

		private PowerOfDotNet.Components.BoardLactureData MakeDbData()
		{
			PowerOfDotNet.Components.BoardLactureData oData = new PowerOfDotNet.Components.BoardLactureData();

			oData.ID = Convert.ToInt32(ViewState["id"]);
			oData.Subject = txtSubject.Text;
			oData.Format = Convert.ToByte(rdobtnFormat.SelectedItem.Value);
			oData.Content = txtContent.Text;
			oData.UserIP = Request.ServerVariables["REMOTE_ADDR"];
			oData.UseAvatar = chkboxUseAvatar.Checked;
			oData.AvatarExpression = Convert.ToByte(rdobtnlstAvatarExp.SelectedItem.Value);

			return oData;
		}

	}
}
