/*
 * 2004 2 20 
 * */

namespace PowerOfDotNet.WebMail
{
	using System;
	using System.Data;
	using System.Data.SqlClient;
	using System.Drawing;
	using System.Web;
	using System.Web.UI;
	using System.Collections;
	using System.Web.UI.WebControls;
	using System.Web.UI.HtmlControls;

	/// <summary>
	///    б,  , 뿡 
	///  Ѵ.
	/// </summary>
	public abstract class WebmailReadMail : PowerOfDotNet.PortalModuleControlEx
	{
		protected System.Web.UI.WebControls.PlaceHolder placehdrMailList;
		protected System.Web.UI.WebControls.PlaceHolder placehdrMailContent;
		protected System.Web.UI.WebControls.LinkButton lnkbtnToMailList;
		protected System.Web.UI.WebControls.Label lblSubject;
		protected System.Web.UI.WebControls.Label lblRegDate;
		protected System.Web.UI.WebControls.Label lblTo;
		protected System.Web.UI.WebControls.Label lblContent;
		protected System.Web.UI.WebControls.Repeater repeatFiles;
		protected System.Web.UI.WebControls.DataGrid datgrdMailList;
		protected System.Web.UI.WebControls.Button btnDeleteAll;
		protected System.Web.UI.WebControls.Button btnToWastebasket;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnReplyMail;
		protected System.Web.UI.HtmlControls.HtmlInputButton btnDeleteMail;
		protected System.Web.UI.WebControls.HyperLink hyplnkFrom;
		protected System.Web.UI.WebControls.HyperLink hyplnkAddAddressBook;
		protected System.Web.UI.WebControls.Label lblMailBoxType1;
		protected System.Web.UI.WebControls.Label lblMailBoxType2;
		protected System.Web.UI.WebControls.Button btnDeleteWastebasket;
		protected System.Web.UI.WebControls.Button btnToRecivedBoxMail;

		private int registerArrayCount = 0;

		private void Page_Load(object sender, System.EventArgs e)
		{
			if (!IsPostBack)
			{
				int mailBoxType = MyWebLibs.Utilities.CommonMethods.RequestInt(Request.Params["mailboxtype"], 0);
				string[] aBoxType = new string[] {" ", " ", " "};
				lblMailBoxType1.Text = aBoxType[mailBoxType];
				lblMailBoxType2.Text = aBoxType[mailBoxType];
				this.ViewState["mailBoxType"] = mailBoxType;

				// ڽ ŸԿ  ư ¸ Ѵ.
				switch (mailBoxType) {
					case 0 :
						btnToRecivedBoxMail.Text = "";
						break;
					case 1 :
						btnToWastebasket.Visible = false;
						btnToRecivedBoxMail.Visible = false;
						break;
					case 2 :
						btnDeleteWastebasket.Visible = true;
						btnToWastebasket.Text = " ";
						break;
				}

				BindData();
			}
		}

		private void BindData()
		{
			datgrdMailList.DataSource = CreateDataSource();
			datgrdMailList.DataBind();
		}

		//Ÿҽ 
		private ICollection CreateDataSource()
		{
			DataTable dt = new DataTable();
			DataRow dr;

			dt.Columns.Add(new DataColumn("ID", typeof(Int32)));
			dt.Columns.Add(new DataColumn("No", typeof(Int32)));
			dt.Columns.Add(new DataColumn("FileAttach", typeof(string)));
			dt.Columns.Add(new DataColumn("Subject", typeof(string)));
			dt.Columns.Add(new DataColumn("From", typeof(string)));
			dt.Columns.Add(new DataColumn("FromAddress", typeof(string)));
			dt.Columns.Add(new DataColumn("MailSize", typeof(Int32)));
			dt.Columns.Add(new DataColumn("RegDate", typeof(string)));

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();

			//   ´.
			//° ڴ   ڽ Ÿ̴.
			DataSet ds = db.GetUserMailList(Page.User.Identity.Name, (byte)(int)ViewState["mailBoxType"]);

			DataRowCollection drList = ds.Tables[0].Rows;
			int intTotalCount = drList.Count;
			int intPageSize = datgrdMailList.PageSize;
			int intCurrentPage = datgrdMailList.CurrentPageIndex;

			// ߻ϸ   ؾѴ.
			while (intPageSize * intCurrentPage >= intTotalCount)
				intCurrentPage--;

			if (intCurrentPage < 0)
				intCurrentPage = 0;

			datgrdMailList.CurrentPageIndex = intCurrentPage;
			datgrdMailList.VirtualItemCount = intTotalCount;
			
			// ȣ ϱ Ѵ.
			int intNo = intTotalCount - (intPageSize * intCurrentPage);
			int intStartRow = intCurrentPage * intPageSize;
			int intEndRow = (intStartRow+intPageSize <= intTotalCount) ? intStartRow+intPageSize : intTotalCount;

			for (int intIndex=intStartRow; intIndex < intEndRow; intIndex++)
			{
				dr = dt.NewRow();

				dr[0] = drList[intIndex]["ID"].ToString();
				dr[1] = intNo--; // Խùȣ
				dr[2] = (bool)drList[intIndex]["FileAttach"] ? "attach.gif" : "attach-blink.gif";
				if (!(bool)drList[intIndex]["Viewed"])
                    dr[3] = "<b>" + drList[intIndex]["Subject"].ToString() + "</b>"; //Subject
				else
					dr[3] = drList[intIndex]["Subject"].ToString(); //Subject

				string from = drList[intIndex]["From"].ToString();
				int indexAddr = from.IndexOf("<");
				if (indexAddr < 0)  indexAddr = 0;
				dr[4] = from.Substring(0, indexAddr); //From
				dr[5] = from.Substring(indexAddr).Replace("<","").Replace(">","");
				dr[6] = (int)drList[intIndex]["MailSize"] / 1024; //ũ
				dr[7] = Convert.ToDateTime(drList[intIndex]["RegDate"]).ToString("yyyy MM dd"); //RegDate

				dt.Rows.Add(dr);
			}

			DataView dv = new DataView(dt);
			return dv;
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN:  ȣ ASP.NET Web Form ̳ʿ ʿմϴ.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		///		̳  ʿ ޼Դϴ.
		///		 ޼  ڵ   ʽÿ.
		/// </summary>
		private void InitializeComponent()
		{
			this.btnDeleteAll.Click += new System.EventHandler(this.btnDeleteAll_Click);
			this.btnToWastebasket.Command += new System.Web.UI.WebControls.CommandEventHandler(this.btnToWastebasket_Command);
			this.btnDeleteWastebasket.Click += new System.EventHandler(this.btnDeleteWastebasket_Click);
			this.datgrdMailList.ItemCommand += new System.Web.UI.WebControls.DataGridCommandEventHandler(this.datgrdMailList_ItemCommand);
			this.datgrdMailList.PageIndexChanged += new System.Web.UI.WebControls.DataGridPageChangedEventHandler(this.datgrdMailList_PageIndexChanged);
			this.datgrdMailList.ItemDataBound += new System.Web.UI.WebControls.DataGridItemEventHandler(this.datgrdMailList_ItemDataBound);
			this.btnToRecivedBoxMail.Click += new System.EventHandler(this.btnToRecivedBoxMail_Click);
			this.lnkbtnToMailList.Click += new System.EventHandler(this.lnkbtnToMailList_Click);
			this.btnReplyMail.ServerClick += new System.EventHandler(this.btnReplyMail_ServerClick);
			this.btnDeleteMail.ServerClick += new System.EventHandler(this.btnDeleteMail_ServerClick);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		//  DataGrid ε ɶ ȣѴ.
		protected string GetWriteMailLink(object dataItem)
		{
			return GetLink("Ͼ") + "&mode=send&to=" + 
				Server.UrlEncode((string)DataBinder.Eval(dataItem, "FromAddress"));
		}

		private void datgrdMailList_PageIndexChanged(object source, System.Web.UI.WebControls.DataGridPageChangedEventArgs e)
		{
			((DataGrid)source).CurrentPageIndex = e.NewPageIndex;
			BindData();		
		}

		private void datgrdMailList_ItemCommand(object source, System.Web.UI.WebControls.DataGridCommandEventArgs e)
		{
			//  Ͽ  Ŭϸ Ⱑ ȴ.
			//      ش.
			if (((LinkButton)e.CommandSource).CommandName == "ViewContent")
			{
				int id = Convert.ToInt32(e.Item.Cells[0].Text);
				this.ViewState["CurentMailID"] = id;

				//     ̵Ѵ.
				placehdrMailList.Visible = false;
				placehdrMailContent.Visible = true;

				PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
				//   
				SqlDataReader dr = db.GetMailContent(id);

				if (dr.Read())
				{
					lblSubject.Text = (string)dr["Subject"];
					string from = (string)dr["From"];
					hyplnkFrom.Text = Server.HtmlEncode(from);
					hyplnkFrom.NavigateUrl = GetLink("Ͼ") + "&mode=send&to=" + Server.UrlEncode(hyplnkFrom.Text);
					string name = String.Empty;

					// ּҿ <ּ>  ڿ ġ
					int addrStart = from.IndexOf("<");
					if (addrStart != -1)
						name = from.Substring(0, addrStart);
					else
						addrStart = 0;

					hyplnkAddAddressBook.NavigateUrl = GetLink("ּҷϰ") + "&name=" + 
								name + "&email=" + from.Substring(addrStart);
					lblRegDate.Text = Convert.ToDateTime(dr["RegDate"]).ToString("yyyy MM dd HH:mm");

					//HTML    ؽƮ 
					//   ´.
					string strBody = (string)dr["HtmlBody"];
					if (strBody.Trim() == String.Empty)
						strBody = ((string)dr["TextBody"]).Replace("\n", "<br>");

					lblContent.Text = strBody;
					lblTo.Text = ((string)dr["To"]).Replace(";", ",");
				}
				db.UserMailViewed(id);

				DataTable dt = new DataTable();
				DataRow drRow;

				dt.Columns.Add(new DataColumn("FileName", typeof(string)));
				dt.Columns.Add(new DataColumn("FileLink", typeof(string)));
				dt.Columns.Add(new DataColumn("FileSize", typeof(Int32)));

				dr.NextResult();
				while(dr.Read())
				{
					drRow = dt.NewRow();

					drRow[0] = dr["FileName"].ToString();
					drRow[1] = "/WebMail/DownloadMailAttach.ashx?file=" + drRow[0].ToString() + 
						"&savedFile=" + dr["SavedFileName"].ToString() + "&bypass=true";
					drRow[2] = (int)dr["Size"] / 1024; //ũ

					dt.Rows.Add(drRow);
				}

				dr.Close();

				repeatFiles.DataSource = new DataView(dt);
				repeatFiles.DataBind();
			}
		}

		private void datgrdMailList_ItemDataBound(object sender, System.Web.UI.WebControls.DataGridItemEventArgs e)
		{
			if(e.Item.ItemType == ListItemType.Item || 
				e.Item.ItemType == ListItemType.AlternatingItem) {
				if (((ICollection)((DataGrid)sender).DataSource).Count > registerArrayCount) {
					CheckBox oc = (CheckBox)e.Item.Cells[1].FindControl("chkboxCheck");
					oc.Attributes["onclick"] = "__webmailSetCheckAllBox()";
					this.Page.RegisterArrayDeclaration("__WebmailReadListCheckBoxArr", "document.getElementById(\"" + oc.ClientID + "\")");
					registerArrayCount++; // ޼ҵ尡 ѹ̻ ݺǴ 찡 Ƿ
				}
			}
		}

		// 뺸⿡  Ϻ Ѵ.
		private void lnkbtnToMailList_Click(object sender, System.EventArgs e)
		{
			placehdrMailList.Visible = true;
			placehdrMailContent.Visible = false;
			BindData();
		}

		//Ͽ õ ϵ  Ѵ.
		private void btnDeleteAll_Click(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			//  ͸ Ѵ.
			string filePath = this.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/mail_file/");

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			foreach (DataGridItem item in datgrdMailList.Items)
			{
				if (((CheckBox)item.Cells[1].FindControl("chkboxCheck")).Checked)
				{
					db.DeleteMail(Convert.ToInt32(item.Cells[0].Text), filePath);
				}
			}
			BindData();
		}

		//Ͽ õ ϵ Ϲڽ ̵Ѵ.
		private void btnToWastebasket_Command(object sender, System.Web.UI.WebControls.CommandEventArgs e)
		{
			int mailBoxType = (int)this.ViewState["mailBoxType"] == 0 ? 2 : 0;

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			foreach (DataGridItem item in datgrdMailList.Items)
			{
				if (((CheckBox)item.Cells[1].FindControl("chkboxCheck")).Checked)
				{
					//   ڽ Ÿ 
					db.MoveMailBox(Convert.ToInt32(item.Cells[0].Text), (byte)mailBoxType);
				}
			}
			BindData();		
		}

		//亯  Ͼ  ̵
		private void btnReplyMail_ServerClick(object sender, System.EventArgs e)
		{
			string subject = Server.UrlEncode(lblSubject.Text);
			string to = Server.UrlEncode(hyplnkFrom.Text);
			Response.Redirect(GetLink("Ͼ") + "&mode=reply&to=" + to + "&subject=" + subject);
		}

		//  ִ  Ѵ.
		private void btnDeleteMail_ServerClick(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			//  ͸ Ѵ.
			string filePath = this.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/mail_file/");

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			// ID  DB ϰ ÷ε ϵ Ѵ.
			db.DeleteMail(Convert.ToInt32(this.ViewState["CurentMailID"]), filePath);

			placehdrMailList.Visible = true;
			placehdrMailContent.Visible = false;
			BindData();
		}

		// ü .
		private void btnDeleteWastebasket_Click(object sender, System.EventArgs e)
		{
			string userId = this.Page.User.Identity.Name;
			string userDir = Request.Cookies["usersInfo"]["UserDir"].ToString();

			//  ͸ Ѵ.
			string filePath = this.MapPath("/User/UserDir/" + userDir 
				+ "/" + userId + "/mail_file/");

			Components.WebmailDB db = new Components.WebmailDB();
			DataSet ds = db.GetUserMailList(this.Page.User.Identity.Name, (byte)(int)this.ViewState["mailBoxType"]);

			foreach (DataRow row in ds.Tables[0].Rows)
			{
				db.DeleteMail((int)row["ID"], filePath);
			}
			BindData();
		}

		// ִ  Ϲڽ ̵Ѵ.
		private void btnToRecivedBoxMail_Click(object sender, System.EventArgs e)
		{
			int mailId = (int)this.ViewState["CurentMailID"];
			// Ϲڽ ŸԿ  ̵  ڽ Ÿ ޶.
			int destMailBoxType = (int)this.ViewState["mailBoxType"] == 0 ? 2 : 0;

			PowerOfDotNet.Components.WebmailDB db = new PowerOfDotNet.Components.WebmailDB();
			//   ڽ Ÿ Ѵ.
			db.MoveMailBox(mailId, (byte)destMailBoxType);

			//  Ⱥ̰   ̵
			placehdrMailList.Visible = true;
			placehdrMailContent.Visible = false;

			BindData();
		}
	}
}
